OGRE-Next: Ogre::GLSLShader Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Classes | Public Member Functions | Static Public Member Functions | List of all members
Ogre::GLSLShader Class Referencefinal

Specialisation of HighLevelGpuProgram to encapsulate shader objects obtained from compiled shaders written in the OpenGL Shader Language (GLSL). More...

`#include <OgreGLSLShader.h>`

Inheritance diagram for Ogre::GLSLShader:
[legend]

## Classes
class | CmdAttach
| Command object for attaching another GLSL Program. More...
class | CmdColumnMajorMatrices
| Command object for setting matrix packing in column-major order. More...
class | CmdInputOperationType
| Command object for setting the input operation type (geometry shader only) More...
class | CmdMaxOutputVertices
| Command object for setting the maximum output vertices (geometry shader only) More...
class | CmdOutputOperationType
| Command object for setting the output operation type (geometry shader only) More...
class | CmdPreprocessorDefines
| Command object for setting macro defines. More...

## Public Member Functions
| GLSLShader (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual, ManualResourceLoader *loader)
| ~GLSLShader () override
GpuProgram * | _getBindingDelegate () override
| Since GLSL has no assembly, use this shader for binding.
void | attachChildShader (const String &name)
| Attach another GLSL Shader to this one.
void | attachToProgramObject (const GLuint programObject)
void | bind ()
| Bind the shader in OpenGL.
void | bindParameters (GpuProgramParametersSharedPtr params, uint16 mask)
| Execute the param binding functions for this shader.
void | bindPassIterationParameters (GpuProgramParametersSharedPtr params)
| Execute the pass iteration param binding functions for this shader.
size_t | calculateSize () const override
| Calculate the size of a resource; this will only be called after 'load'.
bool | compile (const bool checkErrors=false)
| Compile source into shader object.
GpuProgramParametersSharedPtr | createParameters () override
| Overridden from GpuProgram.
void | detachFromProgramObject (const GLuint programObject)
String | getAttachedShaderNames () const
bool | getColumnMajorMatrices () const
| Gets whether matrix packed in column-major order.
GLuint | getGLShaderHandle () const
GLenum | getGLShaderType (GpuProgramType programType)
| Get OpenGL GLSL shader type from OGRE GPU program type.
virtual OperationType | getInputOperationType () const
| Returns the operation type that this geometry program expects to receive as input.
const String & | getLanguage () const override
| Overridden from GpuProgram.
virtual int | getMaxOutputVertices () const
| Returns the maximum number of vertices that this geometry program can output in a single run.
virtual OperationType | getOutputOperationType () const
| Returns the operation type that this geometry program will emit.
bool | getPassFogStates () const override
| Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override)
bool | getPassSurfaceAndLightStates () const override
| Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override)
bool | getPassTransformStates () const override
| Overridden.
const String & | getPreprocessorDefines () const
| Sets the preprocessor defines use to compile the program.
GLuint | getShaderID () const
| Get the OGRE assigned shader ID.
String | getShaderTypeLabel (GpuProgramType programType)
| Get a string containing the name of the GLSL shader type correspondening to the OGRE GPU program type.
GLint | isLinked ()
| Return the shader link status.
void | setColumnMajorMatrices (bool columnMajor)
| Sets whether matrix packing in column-major order.
virtual void | setInputOperationType (OperationType operationType)
| Sets the operation type that this geometry program expects to receive.
void | setLinked (GLint flag)
| Set the shader link status.
virtual void | setMaxOutputVertices (int maxOutputVertices)
| Set the maximum number of vertices that a single run of this geometry program can emit.
virtual void | setOutputOperationType (OperationType operationType)
| Set the operation type that this geometry program will emit.
void | setPreprocessorDefines (const String &defines)
| Sets the preprocessor defines use to compile the program.
void | setReplaceVersionMacro (bool bReplace) override
| When true:
void | unbind ()
| Unbind the shader in OpenGL.
Public Member Functions inherited from Ogre::HighLevelGpuProgram
| HighLevelGpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor, should be used only by factory classes.
| ~HighLevelGpuProgram () override
GpuProgram * | _getBindingDelegate () override
| Returns the GpuProgram which should be bound to the pipeline.
size_t | calculateSize () const override
| Calculate the size of a resource; this will only be called after 'load'.
GpuProgramParametersSharedPtr | createParameters () override
| Creates a new parameters object compatible with this program definition.
const GpuNamedConstants & | getConstantDefinitions () const override
| Get the full list of GpuConstantDefinition instances.
bool | getEnableIncludeHeader () const
bool | getUseHlmsParser () const
void | setEnableIncludeHeader (bool bEnable)
| Whether we should parse the source code looking for include files and embedding the file.
void | setUseHlmsParser (bool bUse)
| Whether we should run the shader through the Hlms parser.
Public Member Functions inherited from Ogre::GpuProgram
| GpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| ~GpuProgram () override
bool | getBuildParametersFromReflection () const
virtual Vector3 | getComputeGroupDimensions () const
| Returns the number of process groups dispatched by this compute program.
virtual GpuProgramParametersSharedPtr | getDefaultParameters ()
| Get a reference to the default parameters which are to be used for all uses of this program.
virtual const String & | getManualNamedConstantsFile () const
| Gets the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
virtual ushort | getNumberOfPosesIncluded () const
| Returns the number of simultaneous poses the vertex program can blend, for use in pose animation.
uint8 | getNumClipDistances () const
| Retrieves the number of clip distances. See GpuProgram::setNumClipDistances.
virtual const String & | getSource () const
| Gets the assembler source for this program.
virtual const String & | getSourceFile () const
| Gets the name of the file used as source for this program.
virtual const String & | getSyntaxCode () const
| Gets the syntax code for this program e.g.
virtual GpuProgramType | getType () const
| Get the program type.
virtual bool | hasCompileError () const
| Did this program encounter a compile error when loading?
virtual bool | hasDefaultParameters () const
| Returns true if default parameters have been set up.
virtual bool | isAdjacencyInfoRequired () const
| Returns whether this geometry program requires adjacency information from the input primitives.
virtual bool | isMorphAnimationIncluded () const
| Returns whether a vertex program includes the required instructions to perform morph animation.
virtual bool | isPoseAnimationIncluded () const
| Returns whether a vertex program includes the required instructions to perform pose animation.
virtual bool | isSkeletalAnimationIncluded () const
| Returns whether a vertex program includes the required instructions to perform skeletal animation.
virtual bool | isSupported () const
| Returns whether this program can be supported on the current renderer and hardware.
virtual bool | isVertexTextureFetchRequired () const
| Returns whether this vertex program requires support for vertex texture fetch from the hardware.
virtual bool | isVpAndRtArrayIndexFromAnyShaderRequired () const
| Returns whether this program requires support for choosing viewport or render target index in any program or only geometry one.
virtual void | resetCompileError ()
| Reset a compile error if it occurred, allowing the load to be retried.
virtual void | setAdjacencyInfoRequired (bool r)
| Sets whether this geometry program requires adjacency information from the input primitives.
virtual void | setAutoReflectArrayBindingsInRootLayout (bool bReflectArrayRootLayouts)
| Set to true to reflects the shader looking for array bindings (e.g.
void | setBuildParametersFromReflection (bool buildParams)
virtual void | setComputeGroupDimensions (Vector3 dimensions)
| Sets the number of process groups dispatched by this compute program.
virtual void | setManualNamedConstants (const GpuNamedConstants &namedConstants)
| Allows you to manually provide a set of named parameter mappings to a program which would not be able to derive named parameters itself.
virtual void | setManualNamedConstantsFile (const String &paramDefFile)
| Specifies the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
virtual void | setMorphAnimationIncluded (bool included)
| Sets whether a vertex program includes the required instructions to perform morph animation.
void | setNumClipDistances (const uint8 numClipDistances)
| Sets the number of clip distances this shader uses.
virtual void | setPoseAnimationIncluded (ushort poseCount)
| Sets whether a vertex program includes the required instructions to perform pose animation.
void | setPrefabRootLayout (const PrefabRootLayout::PrefabRootLayout &prefab)
| Sets a prefab root layout, mostly meant for low level materials (e.g.
virtual void | setRootLayout (GpuProgramType t, const RootLayout &rootLayout)
| Sets a RootLayout programmatically, thus the shader source won't be parsed looking for one We will call validate()
virtual void | setSkeletalAnimationIncluded (bool included)
| Sets whether a vertex program includes the required instructions to perform skeletal animation.
virtual void | setSource (const String &source)
| Sets the source assembly for this program from an in-memory string.
virtual void | setSource (const String &source, const String &debugFilename)
| Sets the source assembly for this program from an in-memory string, while providing a path to a file, which can be needed/useful for debugging shaders (i.e.
virtual void | setSourceFile (const String &filename)
| Sets the filename of the source assembly for this program.
virtual void | setSyntaxCode (const String &syntax)
| Sets the syntax code for this program e.g.
virtual void | setType (GpuProgramType t)
| Set the program type (only valid before load)
virtual void | setVertexTextureFetchRequired (bool r)
| Sets whether this vertex program requires support for vertex texture fetch from the hardware.
virtual void | setVpAndRtArrayIndexFromAnyShaderRequired (bool r)
| Sets whether this program requires support for choosing viewport or render target index in any program or only geometry one.
virtual void | unsetRootLayout ()
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event.
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event.
virtual void | _fireUnloadingComplete ()
| Firing of unloading complete event.
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
virtual ResourceManager * | getCreator ()
| Gets the manager which created this resource.
virtual const String & | getGroup () const
| Gets the group which this resource is a member of.
virtual ResourceHandle | getHandle () const
virtual LoadingState | getLoadingState () const
| Returns the current loading state.
virtual const String & | getName () const
| Gets resource name.
virtual const String & | getOrigin () const
| Get the origin of this resource, e.g.
virtual size_t | getSize () const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
virtual bool | isBackgroundLoaded () const
| Returns whether this Resource has been earmarked for background loading.
virtual bool | isLoaded () const
| Returns true if the Resource has been loaded, false otherwise.
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
virtual bool | isManuallyLoaded () const
| Is this resource manually loaded?
virtual bool | isPrepared () const
| Returns true if the Resource has been prepared, false otherwise.
virtual bool | isReloadable () const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
bool | markForReload ()
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | setManuallyLoaded (bool isManual)
| Set "Is this resource manually loaded?".
virtual void | setToLoaded ()
| Change the Resource loading state to loaded.
virtual void | touch ()
| 'Touches' the resource to indicate it has been used.
virtual void | unload ()
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary ()
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary () const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters () const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.

## Static Public Member Functions
static void | unbindAll ()
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Additional Inherited Members
Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 , LF_MARKED_FOR_RELOAD = 8 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING , LOADSTATE_UNLOADED_MARKED_FOR_RELOAD }
| Enum identifying the loading state of the resource. More...
Public Attributes inherited from Ogre::Resource
| OGRE_AUTO_MUTEX
Static Public Attributes inherited from Ogre::HighLevelGpuProgram
static CmdEnableIncludeHeader | msEnableIncludeHeaderCmd
static CmdUseHlmsParser | msUseHlmsParser

## Detailed Description

Specialisation of HighLevelGpuProgram to encapsulate shader objects obtained from compiled shaders written in the OpenGL Shader Language (GLSL).

Remarks
  GLSL has no target assembler or entry point specification like DirectX 9 HLSL. Vertex and Fragment shaders only have one entry point called "main". When a shader is compiled, microcode is generated but can not be accessed by the application. GLSL also does not provide assembler low level output after compiling. The GL Render system assumes that the Gpu program is a GL GPU program so GLSLShader will create a GL3PlusShader for the low level implementation. The GLSLShader class will create a shader object and compile the source but will not create a program object. It's up to GL3PlusShader class to request a program object to link the shader object to.

Note
  GLSL supports multiple modular shader objects that can be attached to one program object to form a single shader. This is supported through the "attach" material script command. All the modules to be attached are listed on the same line as the attach command separated by white space.

## Constructor & Destructor Documentation

## ◆ GLSLShader()

Ogre::GLSLShader::GLSLShader | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual,
|  | ManualResourceLoader * | loader )

## ◆ ~GLSLShader()

Ogre::GLSLShader::~GLSLShader | ( |  | ) |
| override

## Member Function Documentation

## ◆ _getBindingDelegate()

GpuProgram * Ogre::GLSLShader::_getBindingDelegate | ( |  | ) |
| inlineoverridevirtual

Since GLSL has no assembly, use this shader for binding.

Reimplemented from Ogre::GpuProgram.

## ◆ attachChildShader()

void Ogre::GLSLShader::attachChildShader | ( | const String & | name | ) |

Attach another GLSL Shader to this one.

## ◆ attachToProgramObject()

void Ogre::GLSLShader::attachToProgramObject | ( | const GLuint | programObject | ) |

## ◆ bind()

void Ogre::GLSLShader::bind | ( |  | ) |

Bind the shader in OpenGL.

## ◆ bindParameters()

void Ogre::GLSLShader::bindParameters | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask )

Execute the param binding functions for this shader.

## ◆ bindPassIterationParameters()

void Ogre::GLSLShader::bindPassIterationParameters | ( | GpuProgramParametersSharedPtr | params | ) |

Execute the pass iteration param binding functions for this shader.

## ◆ calculateSize()

size_t Ogre::GLSLShader::calculateSize | ( |  | ) | const
| overridevirtual

Calculate the size of a resource; this will only be called after 'load'.

Reimplemented from Ogre::Resource.

## ◆ compile()

bool Ogre::GLSLShader::compile | ( | const bool | checkErrors = false | ) |

Compile source into shader object.

## ◆ createParameters()

GpuProgramParametersSharedPtr Ogre::GLSLShader::createParameters | ( |  | ) |
| overridevirtual

Overridden from GpuProgram.

Reimplemented from Ogre::GpuProgram.

## ◆ detachFromProgramObject()

void Ogre::GLSLShader::detachFromProgramObject | ( | const GLuint | programObject | ) |

## ◆ getAttachedShaderNames()

String Ogre::GLSLShader::getAttachedShaderNames | ( |  | ) | const
| inline

## ◆ getColumnMajorMatrices()

bool Ogre::GLSLShader::getColumnMajorMatrices | ( |  | ) | const
| inline

Gets whether matrix packed in column-major order.

## ◆ getGLShaderHandle()

GLuint Ogre::GLSLShader::getGLShaderHandle | ( |  | ) | const
| inline

## ◆ getGLShaderType()

GLenum Ogre::GLSLShader::getGLShaderType | ( | GpuProgramType | programType | ) |

Get OpenGL GLSL shader type from OGRE GPU program type.

## ◆ getInputOperationType()

virtual OperationType Ogre::GLSLShader::getInputOperationType | ( |  | ) | const
| inlinevirtual

Returns the operation type that this geometry program expects to receive as input.

## ◆ getLanguage()

const String & Ogre::GLSLShader::getLanguage | ( |  | ) | const
| overridevirtual

Overridden from GpuProgram.

Reimplemented from Ogre::GpuProgram.

## ◆ getMaxOutputVertices()

virtual int Ogre::GLSLShader::getMaxOutputVertices | ( |  | ) | const
| inlinevirtual

Returns the maximum number of vertices that this geometry program can output in a single run.

## ◆ getOutputOperationType()

virtual OperationType Ogre::GLSLShader::getOutputOperationType | ( |  | ) | const
| inlinevirtual

Returns the operation type that this geometry program will emit.

## ◆ getPassFogStates()

bool Ogre::GLSLShader::getPassFogStates | ( |  | ) | const
| overridevirtual

Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override)

Remarks
  On DirectX, shader model 2 and earlier continues to have fixed-function fog applied to it, so fog state is still passed (you should disable fog on the pass if you want to perform fog in the shader). In OpenGL it is also common to be able to access the fixed-function fog state inside the shader.

Reimplemented from Ogre::GpuProgram.

## ◆ getPassSurfaceAndLightStates()

bool Ogre::GLSLShader::getPassSurfaceAndLightStates | ( |  | ) | const
| overridevirtual

Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override)

Remarks
  Most vertex programs do not need this material information, however GLSL shaders can refer to this material and lighting state so enable this option

Reimplemented from Ogre::GpuProgram.

## ◆ getPassTransformStates()

bool Ogre::GLSLShader::getPassTransformStates | ( |  | ) | const
| overridevirtual

Overridden.

Reimplemented from Ogre::GpuProgram.

## ◆ getPreprocessorDefines()

const String & Ogre::GLSLShader::getPreprocessorDefines | ( |  | ) | const
| inline

Sets the preprocessor defines use to compile the program.

## ◆ getShaderID()

GLuint Ogre::GLSLShader::getShaderID | ( |  | ) | const
| inline

Get the OGRE assigned shader ID.

## ◆ getShaderTypeLabel()

String Ogre::GLSLShader::getShaderTypeLabel | ( | GpuProgramType | programType | ) |

Get a string containing the name of the GLSL shader type correspondening to the OGRE GPU program type.

## ◆ isLinked()

GLint Ogre::GLSLShader::isLinked | ( |  | ) |
| inline

Return the shader link status.

Only used for separable programs.

## ◆ setColumnMajorMatrices()

void Ogre::GLSLShader::setColumnMajorMatrices | ( | bool | columnMajor | ) |
| inline

Sets whether matrix packing in column-major order.

## ◆ setInputOperationType()

virtual void Ogre::GLSLShader::setInputOperationType | ( | OperationType | operationType | ) |
| inlinevirtual

Sets the operation type that this geometry program expects to receive.

## ◆ setLinked()

void Ogre::GLSLShader::setLinked | ( | GLint | flag | ) |
| inline

Set the shader link status.

Only used for separable programs.

## ◆ setMaxOutputVertices()

virtual void Ogre::GLSLShader::setMaxOutputVertices | ( | int | maxOutputVertices | ) |
| inlinevirtual

Set the maximum number of vertices that a single run of this geometry program can emit.

## ◆ setOutputOperationType()

virtual void Ogre::GLSLShader::setOutputOperationType | ( | OperationType | operationType | ) |
| inlinevirtual

Set the operation type that this geometry program will emit.

## ◆ setPreprocessorDefines()

void Ogre::GLSLShader::setPreprocessorDefines | ( | const String & | defines | ) |

Sets the preprocessor defines use to compile the program.

## ◆ setReplaceVersionMacro()

void Ogre::GLSLShader::setReplaceVersionMacro | ( | bool | bReplace | ) |
| overridevirtual

When true:

On OpenGL: Finds the first occurrence of "ogre_glsl_ver_xxx" and only keeps "xxx" e.g. ogre_glsl_ver_330 becomes 330, ogre_glsl_ver_430 becomes 430

On Vulkan: Finds the first occurrence of "ogre_glsl_ver_xxx" and replaces it with "450"

This is disabled by default because we must scan the entire source and it's just wasted cycles when using Hlms.

However it is enabled by default on low level materials, because their source length tends to be very short and it is extremely useful/practical there

Parameters

  bReplace |

Reimplemented from Ogre::GpuProgram.

## ◆ unbind()

void Ogre::GLSLShader::unbind | ( |  | ) |

Unbind the shader in OpenGL.

## ◆ unbindAll()

static void Ogre::GLSLShader::unbindAll | ( |  | ) |
| static

The documentation for this class was generated from the following file:

- OgreGLSLShader.h